import java.awt.*;

public class Efloy extends GooEfloy {

	public Efloy(EfloyParam pr[], String cr, EfloyParam fp[], String fx,
		EfloyParam ep[], String ev) {
			super(pr, cr, fp, fx, ep, ev);
                        eLadderFactor = 0;
	}

	public int collideSameSpecies() {
		safety += (int) MaxSafetyDose;
		return (int) CollisionBrotherFactor;
	}
	
	public int approachSameSpecies(int neighborDist) {
                //int SafetyAddition;
                //SafetyAddition = (int) ((MaxSafetyDose*CollisionDistance)/(neighborDist+CollisionDistance));
                //safety += SafetyAddition;
                int CoopAddition;
                CoopAddition = (int) ((MaxCooperationDose*CollisionDistance)/(neighborDist+CollisionDistance));
                cooperation += CoopAddition;
		return (int) DistBrotherFactor;
	}

        public int approachDifferentSpecies(int neighborDist) {
                //int SafetyAddition;
                //SafetyAddition = (int) ((MaxSafetyDose*CollisionDistance)/(neighborDist+CollisionDistance));
                //safety -= SafetyAddition;
                //if( safety < 0 ) safety = 0;
                int CoopAddition;
                CoopAddition = (int) ((MaxCooperationDose*CollisionDistance)/(neighborDist+CollisionDistance));
                cooperation -= CoopAddition;
                if( cooperation < 0 ) cooperation = 0;
                //return (int) DistLocalFactor;
                return -((int)DistStrangerFactor);
	}
	/**
	* Here we can code predator/prey behavior in subclasses
        * for now, an eFloy is prey.  Colliding with different species
        * takes away stuff.
        * @param neighborStrange The neighbor we hit
        * @return The movement delta
	*/
	public int collideDifferentSpecies(GooEfloy neighborStrange) {
		int rev;
                energy -= MaxEnergyDose;
                safety -= MaxSafetyDose;
                cooperation -= MaxCooperationDose;
                // moderate moving away; you're bit, how fast will you go?
                //rev = (int) CollisionLocalFactor;
                rev = -((int)CollisionStrangerFactor);
                if (energy < 0) energy = 0;
                if (safety < 0) safety = 0;
                if (cooperation < 0) cooperation = 0;
                //if (Efloys.CurrentGeneration > 0) 
                //        Efloys.appcontext.showStatus("Generation #" + Efloys.CurrentGeneration+"  prey "+id+" remaining energy: "+energy);
                //else
                //        Efloys.appcontext.showStatus("Prey "+id+" remaining energy: "+energy);
		return rev;
	}
	/**
        * Process each neighbor of this floy to NumberOfNeighbors
	*/
	public void Process() {
		int rev;
		int i;
		int d;

		xtail = x;
		ytail = y;
		rev = -1;
                //Efloys.deb.showMsg("Process Prey "+id);
		for (i=0;i<NumberOfNeighbors;i++) {
			
			d = dist(neighbors[i]);

			if (d == 0)
				rev = 0;
			else 
				if (d < CollisionDistance) {
					if( !neighbors[i].getClass().equals(this.getClass()) ) {
						rev = collideDifferentSpecies(neighbors[i]);
					} else { 
						rev = collideSameSpecies();
					}
				} else  {
					if( !neighbors[i].getClass().equals(this.getClass()) ) {
                                                rev = approachDifferentSpecies(d);
                                        } else {
                                                rev = approachSameSpecies(d);
                                        }
				}

				if (x < neighbors[i].x)
					vx += ApproachAcceleration*rev;
				else
					vx -= ApproachAcceleration*rev;

				if (y < neighbors[i].y)
					vy += ApproachAcceleration*rev;
				else
					vy -= ApproachAcceleration*rev;
		}
	

		if (vx > MaxSpeed) vx = MaxSpeed;
		if (vx < -MaxSpeed) vx = -MaxSpeed;
		if (vy > MaxSpeed) vy = MaxSpeed;
		if (vy < -MaxSpeed) vy = -MaxSpeed;

		if (x < 1) vx = BounceSpeed;
		if (x > (width-3)) vx = -BounceSpeed;
		//if (xtail > (width-3)) vx = -BounceSpeed;
		if (y < 1) vy = BounceSpeed;
		if (y > (height-1)) vy = -BounceSpeed;

                // Calc velocity and take away energy in proportion
                float v = (float) (Math.sqrt(vx*vx + vy*vy));
                //energy += (int) (v/MaxSpeed*MaxEnergyDose);
                //energy -= (int) (v/MaxSpeed*2.0F);
                energy -= (int) (v/2.0F);

                // if we find food, eat it, this only for lowest lifeforms
                // probability goes up the slower you go, like nature
                if( Efloys.Flip(1.0F/v) ) ++energy;

                //Efloys.deb.showMsg("Prey "+v+" "+MaxSpeed+" "+MaxEnergyDose);
                if (x < width/2) vx += CenterAcceleration;
                if (x > width/2) vx -= CenterAcceleration;
                if (y < height/2) vy += CenterAcceleration;
                if (y > height/2) vy -= CenterAcceleration;

		x += vx;
		y += vy;
		if (energy < 1)	{
			if (Efloys.WithSound)
                                Efloys.preydie.play();
                        //color = Color.green;
                        // the penalty for dying is coming back half starved
                        // the gene pool must have one
                        energy = initialEnergy / 2;
                        safety = safety / 2;
                        cooperation = cooperation / 2;
                        //Efloys.NewGeneration = true;
                        GetFitness();
                        if( Efloys.InEvolution )
                                Efloys.instance.RotRegardless(this);
                        else {
                                x = xtail = 10;
                                y = ytail = 10;
                        }
                        return;
		}

		GetFitness();

	}
        /**
        * Get the display type name, implement as you see fit in subclasses
        * @return The string display name for this type
        */
	public String GetTypeName() {
                return getClass().getName();
	}

        /**
        * Make a baby via factory; result is same type as subclass
        */
        public GooEfloy BabyFactory(EfloyParam pr[], String cr, EfloyParam fp[], String fx,
                EfloyParam ep[], String ev) {
                GooEfloy g = (GooEfloy)(new Efloy(pr, cr, fp, fx, ep, ev));
                g.x = 10;
                g.y = (float)(Math.random()*(double)height);
                // creates values in neighbors array 
                GetNeighbors();
                return g;
        }

        public void SmoothingFunction(int coopFactor, int safeFactor) {
                cooperation -= coopFactor;
                if( cooperation < 0 ) cooperation = 0;
                safety -= safeFactor;
                if( safety < 0 ) safety = 0;
        }

        public boolean IgnoreSpecies(GooEfloy ignore) { return false; }
}
