import java.awt.*;
import java.awt.event.*;
/**
* This module is responsible for the parameter
* update windows.
* This code was originally written by Ariel Dolan
* @author Groff 1/2003
*/
final class EfloyCommand extends Frame implements ItemListener {

	Button Update;
	Button Quit;
	
	Panel ButtonPanel;
	Panel TitlePanel;
	Panel InputPanel;
	Panel EnvironPanel;

	Label TitleLabel;
	CardLayout cardLayout;

	Label EnvLabels[];
	Choice[] EnvChoices;
	Label[] EnvDummiesA;
	Label[] EnvDummiesB;
	Label[] EnvDummiesC;

        GooEfloy floys[];
	int SelectedFloy;
	Font ButtonFont;

	int CurPop;
    
    public EfloyCommand (GooEfloy f[]) {
        super("Control Center");
        floys = f;
        float fi = 0f;
        int i,j;
        
        ButtonFont = new Font("TimesRoman",Font.PLAIN,12);
        setBackground(Color.white);
        setForeground(Color.black);
        InitControls();

        Update = new Button("Update");
        Quit = new Button("Quit");


        ButtonPanel = new Panel();
        ButtonPanel.setLayout(new FlowLayout(FlowLayout.CENTER, 5, 5));
        ButtonPanel.add(Update);
        ButtonPanel.add(Quit);
        ButtonPanel.setFont(ButtonFont);
        this.add("South", ButtonPanel);

        TitlePanel = new Panel();
        TitlePanel.setLayout(new FlowLayout(FlowLayout.CENTER, 15, 15));
        TitleLabel = new Label("Environmental Properties");
        TitlePanel.add(TitleLabel);
        this.add("North",TitlePanel);
        Font TitleFont = new Font("TimesRoman",Font.BOLD,14);
        TitlePanel.setFont(TitleFont);
        TitlePanel.setForeground(Color.blue);

        InputPanel = new Panel();
        cardLayout = new CardLayout(0,0);
        InputPanel.setLayout(cardLayout);

        EnvironPanel = new Panel();
        InitEnviron();
        InputPanel.add("Environ",EnvironPanel);

        this.add("Center",InputPanel);
        //Efloys.appcontext.showStatus("Loading Control Screen");

        this.pack();
        this.hide();
        UpdateTitle("Environmental Properties", false);

	}


	private void InitControls() {

		int i, j;

		EnvLabels = new Label[11];
		EnvChoices = new Choice[11];
		EnvDummiesA = new Label[11];
		EnvDummiesB = new Label[11];
		EnvDummiesC = new Label[11];

		Font font = new Font("TimesRoman",Font.BOLD,12);

		for (i=0;i<11;i++) {
			EnvLabels[i] = new Label("");
			EnvChoices[i] = new Choice();
                        EnvChoices[i].addItemListener(this);
			EnvDummiesA[i] = new Label("");
			EnvDummiesB[i] = new Label("");
			EnvDummiesC[i] = new Label("");
			EnvLabels[i].setFont(font);

		}

	}
	

	private void InitInputPanel(Panel panel, Label[] labels, Choice[] choices, Label[] dummiesa, Label[] dummiesb, Label[] dummiesc, int num) {

		int i;

		GridBagLayout layout = new GridBagLayout();
		panel.setLayout(layout);

		GridBagConstraints constraints = new GridBagConstraints();

		constraints.weightx = 1.0;
		constraints.weighty = 1.0;
		constraints.fill = GridBagConstraints.BOTH;

		for (i=0;i<11;i++) {
 			constraints.gridwidth = 1;
			layout.setConstraints(dummiesa[i], constraints);
			panel.add(dummiesa[i]);

			constraints.gridwidth = 2;
			layout.setConstraints(labels[i], constraints);
			panel.add(labels[i]);

			constraints.gridwidth = 1;
			if (i > num-1) {
				layout.setConstraints(dummiesc[i], constraints);
				panel.add(dummiesc[i]);
			}
			else {
				layout.setConstraints(choices[i], constraints);
				panel.add(choices[i]);
			}


			constraints.gridwidth = GridBagConstraints.REMAINDER;
			layout.setConstraints(dummiesb[i], constraints);
			panel.add(dummiesb[i]);

		}

		panel.resize(panel.preferredSize());

	}


	private void InitEnviron() {

		int i;

		CurPop = floys[0].PopulationSize;

		EnvLabels[0].setText("Population Size");
		EnvLabels[1].setText("Movement Slowdown Attribute");
		EnvLabels[2].setText("Energy Weight factor");
		EnvLabels[3].setText("Safety Weight Factor");
		EnvLabels[4].setText("Cooperation Weight Factor");
		EnvLabels[5].setText("Max. Energy Dose");
		EnvLabels[6].setText("Max. Safety Dose");
		EnvLabels[7].setText("Max. Cooperation Dose");
                EnvLabels[8].setText("Survivors Percent");
		EnvLabels[9].setText("Free Will Factor");
                //EnvLabels[10].setText("Stranger Life Span");


		InitChoice(EnvChoices[0],Efloys.envpars, 12);
		InitChoice(EnvChoices[1],Efloys.envpars, 3);
		InitChoice(EnvChoices[2],Efloys.envpars, 5);
		InitChoice(EnvChoices[3],Efloys.envpars, 6);
		InitChoice(EnvChoices[4],Efloys.envpars, 7);
		InitChoice(EnvChoices[5],Efloys.envpars, 9);
		InitChoice(EnvChoices[6],Efloys.envpars, 10);
		InitChoice(EnvChoices[7],Efloys.envpars, 11);
		InitChoice(EnvChoices[8],Efloys.envpars, 8);
		InitChoice(EnvChoices[9],Efloys.envpars, 13);
                InitChoice(EnvChoices[10],Efloys.envpars, 14);

                //InitInputPanel(EnvironPanel, EnvLabels, EnvChoices, EnvDummiesA, EnvDummiesB, EnvDummiesC, 11);
                InitInputPanel(EnvironPanel, EnvLabels, EnvChoices, EnvDummiesA, EnvDummiesB, EnvDummiesC, 10);
	}



	private void InitChoice(Choice choice, EfloyParam param[], int Parnum) {
               float fi;
                for (int i = 0; i <= param[Parnum].nsteps; i++) {
			fi = (float) (param[Parnum].min + i*param[Parnum].step);
                        choice.addItem(Float.toString(fi));
		}
                choice.select(Float.toString((float) param[Parnum].value));
	}



	private void FillColors(Choice choice) {

		choice.addItem("BLACK");
		choice.addItem("BLUE");
		choice.addItem("CYAN");
		choice.addItem("DARKGRAY");
		choice.addItem("GRAY");
		choice.addItem("GREEN");
		choice.addItem("LIGHTGRAY");
		choice.addItem("MAGENTA");
                choice.addItem("ORANGE");
		choice.addItem("PINK");
		choice.addItem("RED");
		choice.addItem("WHITE");
		choice.addItem("YELLOW");

		choice.select(floys[floys.length-1].GetColorName());
		//choice.select("GREEN");

	}




	private String readString(Choice c, String d) {
                String n;
        
                try {
                        n = c.getSelectedItem();
                } catch (Exception e) {
                        n = d;
                }        
                return n;
        }


        private int readInt(Choice c, int d) {
                int n;
 
                try {
                        n = Integer.parseInt(c.getSelectedItem());
                } catch (NumberFormatException e) {
                        n = d;
                }        
                return n;
        }


        private float readFloat(Choice c, float d) {
                float n;
        
                try {
                        n = Float.valueOf(c.getSelectedItem()).floatValue();
                } catch (NumberFormatException e) {
                        n = d;
                        Efloys.deb.showMsg("num ex def="+n);
                }        
                return n;
        }


        private void UpdateEnviron() {

                Efloys.envpars[12].value = readFloat(EnvChoices[0], Efloys.envpars[12].value);
                Efloys.envpars[3].value = readFloat(EnvChoices[1], Efloys.envpars[3].value);
                Efloys.envpars[5].value = readFloat(EnvChoices[2], Efloys.envpars[5].value);
                Efloys.envpars[6].value = readFloat(EnvChoices[3], Efloys.envpars[6].value);
                Efloys.envpars[7].value = readFloat(EnvChoices[4], Efloys.envpars[7].value);
                Efloys.envpars[9].value = readFloat(EnvChoices[5], Efloys.envpars[9].value);
                Efloys.envpars[10].value = readFloat(EnvChoices[6], Efloys.envpars[10].value);
                Efloys.envpars[11].value = readFloat(EnvChoices[7], Efloys.envpars[11].value);
                Efloys.envpars[8].value = readFloat(EnvChoices[8], Efloys.envpars[8].value);
                Efloys.envpars[13].value = readFloat(EnvChoices[9], Efloys.envpars[9].value);
                Efloys.envpars[14].value = readFloat(EnvChoices[10], Efloys.envpars[10].value);

                Efloys.KICK = Efloys.envpars[13].value;
                Efloys.SLEEP = (long)(Efloys.envpars[3].value);

	}



	void UpdateTitle(String title, boolean WithNumber) {

		TitleLabel.setText(title);
	}


    public boolean action(Event e, Object arg) {
        int i, j, num;
        if (e.target == Update) {
                Efloys.instance.Finished = true;
                try {
                     while(Efloys.instance.running )
                            Thread.sleep(10);
                } catch(InterruptedException ie) {}
                UpdateEnviron();
                Efloys.ResetPopulation = true;
                Efloys.instance.Restart(false);
                Efloys.instance.setEvolution(false);
                Efloys.instance.start();
        }
        if (e.target == Quit) {
            this.hide();
            this.dispose();
            return true;
        }
        return true;

	}


	public boolean handleEvent(Event ev) {

	    if (ev.id == Event.WINDOW_DESTROY) {
                this.hide();
                this.dispose();
                return true;
            } else
                return super.handleEvent(ev);

	}

        public void itemStateChanged(ItemEvent ie)
        {
                    //if (ie.getSource() == choice)
                    //Choice choice = (Choice)ie.getSource();
                    //Efloys.deb.showMsg("Item "+choice.getSelectedIndex()+" "+choice.getSelectedItem());
                    //choice.select(choice.getSelectedIndex());
                    //}
        }


}
    
