import java.applet.*;
import java.awt.*;
import java.net.*;
import java.util.*;
import java.util.Vector;
import java.util.Date;
/**
* This is a more highly Object Oriented eFloys<br> 
* hence, GOOeFloys, Greater Object Oriented eFloys
* This code was originally written by Ariel Dolan
* Modifications created a GooEfloy base class, the primordial goo from which
* predator and prey eFloys spring.  Original code had type checks for
* floy types, hence limiting extensibility.
* @author J. Groff 1/2003
*/
class EfloyCanvas extends Canvas
{
	Image image;
	Color color;
	boolean first;
	boolean reset;
	Image OffImg;
	Graphics OffGra;


	public EfloyCanvas(Image img)	{

		super();
 		image = img;
		color = Color.white;
		setBackground(Color.black);
		setForeground(Color.white);
		first = true;
		reset = false;
		//OffImg = createImage(size().width, size().height);

	}

	public EfloyCanvas(Color c)	{

		super();
 		image = null;
		setBackground(Color.black);
		setForeground(Color.white);
		color = c;
		first = true;
		reset = false;
		//OffImg = createImage(size().width, size().height);

	}

	public void Clear() {

		reset = true;
		repaint();

	}

        /**
        * This is where the main 'Process' method for each Floy gets called
        */
	public void paint(Graphics g) {

		int i;
                GooEfloy Efloy;

		/*
		if (reset) {
			g.setColor(Color.black);
			g.fillRect(0,0,size().width,size().height);
			reset = false;
			return;
		}

		if (image != null)
			g.drawImage(image,0,0,this);
		else {
		}
		*/

		if (Efloys.Efloys != null) {
			for (i=0;i<Efloys.Efloys.length;i++)
	 		{
				try {
					Efloy = Efloys.Efloys[i];
					Efloy.GetNeighbors();
	 				Efloy.Process();
					Efloy.Draw(g);
				}
				catch (Exception e) {
                                        System.out.println("EfloysCanvas Paint "+e.toString());
                                        e.printStackTrace();
				}
	 		}
		}

	}


	public void xpaint(Graphics g) {

		int i;
                GooEfloy Efloy;

		OffImg = createImage(size().width, size().height);

		try {
		    OffGra = OffImg.getGraphics();
		}
                catch (Exception e) {
                        Efloys.appcontext.showStatus("After OffImg e= "+e.toString());
		}


		OffGra.setColor(getBackground());
		OffGra.fillRect(0,0,size().width,size().height);

		for (i=0;i<Efloys.Efloys.length;i++)
	 	{
			Efloy = Efloys.Efloys[i];
			Efloy.GetNeighbors();
	 		Efloy.Process();
			Efloy.Draw(OffGra);
	 	}

		g.drawImage(OffImg, 0, 0, this);
	}


	Graphics GetGra() {

		return this.getGraphics();
	}
}

public class Efloys extends Applet implements Runnable {

	Thread runner;
        static Efloys instance;
	EfloyCanvas canvas;
	EfloyCommand fcommand;
	EfloyInfo finfo;
	EfloyPredefined fpredefined;
        static GooEfloy[] Efloys;
        static GooEfloy[] NewFloys;
	Button Start;
	Button Pause;
	Button Rules;
	Button Info;
	Button Control;
	Button Kick;
	Button Slower;
	Button Faster;
	Button Scramble;
	Button Stranger;
	Button Breed;
	static Button Evolution;
	Button Quit;

	Button Help;
	Button Log;
	Button Predefined;
	Button Numbers;
	Button Sound;
	Button Ranges;

	Graphics gra;
	Panel ControlPanel;
	Panel center;
	Panel center1;
	Label MainTitle;
	URL MainPage;
	static EfloyParam params[];
	static EfloyParam fixpars[];
	static EfloyParam envpars[];
	Font ButtonFont;
	Date StartDate;

	int wa,ha,wc,hc;
	int CurrentBehavior;
	int CurrentNum;
	long CurrentStep;
	long CurrentTotalStep;
	static long CurrentGeneration;
	long CurrentRandom;
        long SumFitness;
        Hashtable SumFitnessTable = new Hashtable();
	boolean running;
	static boolean First;
        static boolean Finished = false;
	static boolean ResetPopulation = true;
	static boolean NewGeneration = false;
	static boolean InEvolution = false;
	static boolean DrawNumbers = false;
	static boolean WithSound = true;
	static boolean InLog = true;
	static boolean LimitedRanges = false;

	static EfloyGeneration FloyGen;
	static Vector HistoryData;

	static int REVDIST;
	static float ACC;
	static float ACCTOMID;	
	static float MAXSPEED;
	static float BOUNCESPEED;
	static float V0;
	static float KICK;
	static long SLEEP;
	static int MARGIN;
	static int NUMNB;
	static int TYPE;
	static String COLOR;


        static AudioClip preddie;
        static AudioClip preydie;
	static AudioClip beep;
        static Image picture;
        static AppletContext appcontext;
	static EfloyLog deb;
	static EfloyLog helpwin;
	static EfloyLog rulewin;
	static Dimension ScreenSize;


	public void init() {
		int i;
		Float temp;
		String s;

		ButtonFont = new Font("TimesRoman",Font.PLAIN,12);

                deb = new EfloyLog("Log Window");
                //deb.toBack();
		deb.hide();
                deb.showMsg("");
                deb.reshape(50,40,540,380);
		deb.start();

	    helpwin = new EfloyLog("Help Window");
	    //helpwin.toBack();
		helpwin.hide();
                helpwin.showMsg("");
		Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
		ScreenSize = d;
		int w = d.width;
		int h = d.height;
		helpwin.reshape(0,0,w-2,h-2);
		CreateHelp(helpwin);

                rulewin = new EfloyLog("Behavioral Rules of eFloys");
                //rulewin.toBack();
		rulewin.hide();
                rulewin.showMsg("");
		rulewin.reshape(2,2,w-2,h-2);
		CreateRules(rulewin);

		setLayout(new BorderLayout());

		Panel bot = new Panel();
		Start = new Button(" Restart ");
		Scramble = new Button(" Scramble ");
                Stranger = new Button(" Insert Predator ");
		Breed = new Button(" Breed ");
		Evolution = new Button(" Start Evolution ");
		Quit = new Button(" Quit ");

		bot.setFont(ButtonFont);

		bot.add(Start);
		bot.add(Scramble);
		bot.add(Breed);
		bot.add(Evolution);
		bot.add(Stranger);
		add("South",bot);

		Numbers = new Button("Show Numbers");
		Sound = new Button("Turn Sound Off");
		Slower = new Button("Move Slower");
		Faster = new Button("Move Faster");
		Pause = new Button("Pause");
		Ranges = new Button("Limited Ranges");
		


		Help = new Button("Show Help");
		Log = new Button("Show Log");
		Predefined = new Button("Predefined");
		Control = new Button("Edit Properties");
		Info = new Button("Show Info");
		Rules = new Button("Show Rules");
		

		Panel west = new Panel();
		west.setLayout(new GridLayout(6,1));
		west.setFont(ButtonFont);

		west.add(Numbers);
		west.add(Sound);
		west.add(Slower);
		west.add(Faster);
		west.add(Pause);
		west.add(Ranges);

		add("West",west);


		Panel east = new Panel();
		east.setLayout(new GridLayout(6,1));
		east.setFont(ButtonFont);

		east.add(Help);
		east.add(Rules);
		east.add(Log);
		east.add(Predefined);
		east.add(Info);
		east.add(Control);

		add("East",east);


		Panel north = new Panel();
		Font BoldFont = new Font("TimesRoman",Font.BOLD,12);
		north.setFont(BoldFont);
		//north.setBackground(Color.blue);
		//north.setForeground(Color.white);
                //MainTitle = new Label(".                 The GOOeFloys Ocean                 .");
                MainTitle = new Label("The GOOeFloys Tank");
		MainTitle.setForeground(Color.black);
		north.add(MainTitle);
		add("North",north);

		appcontext = getAppletContext();
		picture = getImage(getCodeBase(),"Efloys1.gif");
                preddie = getAudioClip(getCodeBase(), "preddie.au");
                preydie = getAudioClip(getCodeBase(), "preydie.au");
		beep = getAudioClip(getCodeBase(), "Beep.au");


		canvas = new EfloyCanvas(Color.red);
		//canvas = new EfloyCanvas(picture);
		add("Center",canvas);
		canvas.repaint();
		gra = canvas.GetGra();

		center = new Panel();
		center.setLayout(new GridLayout(2,2));
		center.add(new Button("B1"));
		center.add(new Button("B2"));
		center.add(new Button("B3"));
		center.add(new Button("B4"));
		//add("Center",center);
		//center.repaint();
		//remove(center);

		center1 = new Panel();
		center1.setLayout(new GridLayout(2,2));
		center1.add(new Button("B1a"));
		center1.add(new Button("B2a"));
		center1.add(new Button("B3a"));
		center1.add(new Button("B4a"));
		//add("Center",center1);

		HistoryData = new Vector();

		//Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
		//resize(d.width-20,250);
                //resize(620,250);

		CurrentBehavior = 0;
		First = true;
                instance = this;

	}

	public void destroy() {

		deb.dispose();
		helpwin.dispose();
		rulewin.dispose();

	}


	public void start()
	{
		if (runner == null)
		{
			runner= new Thread(this);
			runner.start();
			running = true;
			CurrentStep = 0;
			CurrentTotalStep = 0;
			CurrentRandom = 0;
			CurrentGeneration = 0;
		}
	}
	
	public void stop()
	{
		if (runner!=null)
		{
			runner.stop();
			runner=null;
			running = false;
		}
	}


	public void run() {

		if (First) {
			InitParamsExtended();
			GetParameters();
			Restart(false);
                        //randemize();
			First = false;
		}
                deb.showMsg("GOOEfloys Version 3.0");

		while (true) {
                        long st = System.currentTimeMillis();
                        if (First) {
                                First = false;
                                Restart(false);
                        }

                        if( Finished ) {
                                Finished = false;
                                runner = null;
                                running = false;
                                return;
                        }
                                        

			CurrentStep++;
			CurrentTotalStep++;
                        //if (Math.random() < (double)KICK) randemize();

			if (((InEvolution) && (NewGeneration)) || ((InEvolution) &&(CurrentStep > 5000))) {
				StartDate = new Date();
				deb.showMsg("New Generation #"+(CurrentGeneration+1)+" started at "+StartDate.toLocaleString());
				CreateNewGeneration();
			}
		 	canvas.repaint();
                        st = System.currentTimeMillis() - st;
                        if( st > SLEEP ) st = SLEEP;
                        try { Thread.sleep(SLEEP-st);}
		 	catch (InterruptedException e) {
                                showStatus("Thread.sleep InterruptedException "+e.toString());
			}
		}
	}


	float GetOneParameter(String name, float def) {

		String s;
		Float temp;
		float FloatPar;

		s=getParameter(name);
		if (s==null)
			FloatPar=def;
		else {
			temp = new Float(s);
			FloatPar = temp.floatValue();
		}

		return FloatPar;

	}

        /**
        * Extract the chromosonal, fixed, and environmental params
        * that drive the whole process
        */
	void GetParameters() {

		String s;
		Float temp;
		int IntPar;
		float FloatPar;

		params[0].value = GetOneParameter("MaxSpeed",5f);
		params[1].value = GetOneParameter("BounceSpeed",0.8f);
		params[2].value = GetOneParameter("ApproachAcceleration",0.3f);
		params[4].value = GetOneParameter("CenterAcceleration",0.1f);
		params[5].value = GetOneParameter("DistBrotherFactor",1f);
		params[6].value = GetOneParameter("DistStrangerFactor",20f);
		params[7].value = GetOneParameter("DistLocalFactor",0f);
		params[8].value = GetOneParameter("CollisionDistance",200f);
		params[9].value = GetOneParameter("CollisionBrotherFactor",-1f);
		params[10].value = GetOneParameter("CollisionStrangerFactor",30f);
		params[11].value = GetOneParameter("CollisionLocalFactor",-40f);

		fixpars[5].value = GetOneParameter("NumberOfNeighbors",2f);
		fixpars[6].value = GetOneParameter("MutationFactor",0.1f);
		fixpars[7].value = GetOneParameter("CrossoverFactor",1f);
                fixpars[8].value = GetOneParameter("energy",1000f);
		fixpars[9].value = GetOneParameter("safety",10f);
		fixpars[10].value = GetOneParameter("cooperation",10f);

		envpars[5].value = GetOneParameter("EnergyFactor",1f);
		envpars[6].value = GetOneParameter("SafetyFactor",1f);
                envpars[7].value = GetOneParameter("CooperationFactor",1f);
		envpars[8].value = GetOneParameter("SurviversFactor",0f);
		envpars[12].value = GetOneParameter("PopulationSize",15f);
		envpars[13].value = GetOneParameter("FreeWillFactor",0.05f);
		envpars[14].value = GetOneParameter("LifeSpan",50f);

		SLEEP = (long) envpars[3].value;
		KICK =  envpars[13].value;

        }


	public void randemize()
	{
		int i,j,k,n;

		CurrentRandom++;
		for (k=0;k<Efloys.length;k++) {
                        GooEfloy ng = Efloys[k];
			for (j=0;j<ng.NumberOfNeighbors;j++) {
				n =(int) (Math.random()*(Efloys.length-1));
				ng.neighbors[j] = Efloys[n];
			}
		}
	}


	public void scramble() {

		int i;
			
		for (i=0;i<Efloys.length;i++) {
			Efloys[i].shuffle(false,(float) 0.3);
		}
		GetSumFitness();
	}



	public void CreateNewGeneration() {

		//w = GetWinner();
		RecordGeneration();

		CurrentGeneration++;
		PreScale();
		Breed();
		ReleaseStranger();
		NewGeneration = false;
		CurrentStep = 0;
			
		showStatus("Generation #" + CurrentGeneration);
		
	}


	public int GetWinner() {

		int i, winner, e;
			
		e = 0;
		winner = 0;

		for (i=0;i<Efloys.length;i++) {
			Efloys[i].GetFitness();
			if (Efloys[i].fitness > e) {
				e = Efloys[i].fitness;
				winner = i;
			}
		}
		return winner;
	}


	public void RecordGeneration() {

		int i, w, fit;
		float SpeedSum, SpeedAvg, AccSum, AccAvg;
		float DllSum, DllAvg, DslSum, DslAvg, DlsSum, DlsAvg;
		float CllSum, CllAvg, CslSum, CslAvg, ClsSum, ClsAvg;
			
		fit = 0;
		w = 0;
		SpeedSum = 0;
		AccSum = 0;
		DllSum = 0;
		DlsSum = 0;
		DslSum = 0;
		CllSum = 0;
		ClsSum = 0;
		CslSum = 0;

		for (i=0;i<Efloys.length;i++) {
			SpeedSum = SpeedSum + Efloys[i].MaxSpeed;
			AccSum = AccSum + Efloys[i].ApproachAcceleration;
			DllSum = DllSum + Efloys[i].DistBrotherFactor;
			DlsSum = DllSum + Efloys[i].DistStrangerFactor;
			DslSum = DllSum + Efloys[i].DistLocalFactor;
			CllSum = CllSum + Efloys[i].CollisionBrotherFactor;
			ClsSum = CllSum + Efloys[i].CollisionStrangerFactor;
			CslSum = CllSum + Efloys[i].CollisionLocalFactor;

			Efloys[i].GetFitness();
			if (Efloys[i].fitness > fit) {
				fit = Efloys[i].fitness;
				w = i;
			}
		}

		SpeedAvg = (float) SpeedSum/Efloys.length;
		AccAvg = (float) AccSum/Efloys.length;
		DllAvg = (float) DllSum/Efloys.length;
		DlsAvg = (float) DlsSum/Efloys.length;
		DslAvg = (float) DslSum/Efloys.length;
		CllAvg = (float) CllSum/Efloys.length;
		ClsAvg = (float) ClsSum/Efloys.length;
		CslAvg = (float) CslSum/Efloys.length;

		Efloys[w].GetFitness();
                FloyGen = new EfloyGeneration(CurrentGeneration, CurrentStep, 0, Efloys[w].GetTypeName(), Efloys[w].chrom, 
			Efloys[w].fitness, Efloys[w].energy, Efloys[w].safety, 
			Efloys[w].cooperation, Efloys[w].MaxSpeed,Efloys[w].ApproachAcceleration,
			AccSum,AccAvg,DllAvg,DlsAvg,DslAvg,CllAvg,ClsAvg,CslAvg);

		HistoryData.addElement(FloyGen);

	}


	void InitParamsLimited() {

		params = new EfloyParam[12];

                params[0]  = new EfloyParam(1f,5f,0.25f,1f,"MaxSpeed",true);
		params[1]  = new EfloyParam(0.2f,2.2f,0.1f,0.8f,"BounceSpeed",true);
		params[2]  = new EfloyParam(0.1f,1.1f,0.05f,0.3f,"ApproachAcceleration",true);
		params[3]  = new EfloyParam(0.1f,1.1f,0.05f,0.3f,"RetreatAcceleration",true);
		params[4]  = new EfloyParam(0f,0.2f,0.01f,0.1f,"CenterAcceleration",true);

		params[5]  = new EfloyParam(0f,10f,0.5f,1f,"DistBrotherFactor",true);
                params[6]  = new EfloyParam(2.5f,50f,2.5f,20f,"DistStrangerFactor",true);
		params[7]  = new EfloyParam(-50f,50f,0.5f,0f,"DistLocalFactor",true);

		params[8]  = new EfloyParam(0f,500f,25f,200f,"CollisionDistance",true);

		params[9]  = new EfloyParam(-10f,0f,0.5f,-1f,"CollisionBrotherFactor",true);
		params[10] = new EfloyParam(0f,100f,5f,30f,"CollisionStrangerFactor",true);
		params[11] = new EfloyParam(-100f,0f,5f,-40f,"CollisionLocalFactor",true);



		fixpars = new EfloyParam[12];

		fixpars[0] = new EfloyParam(1f,100f,1f,(float) CurrentNum,"id",false);
		fixpars[1] = new EfloyParam(1f,100f,1f,0f,"father",false);
		fixpars[2] = new EfloyParam(1f,100f,1f,0f,"mother",false);
		fixpars[3] = new EfloyParam(0f,10f,1f,0f,"type",false);
		fixpars[4] = new EfloyParam(0f,13f,1f,5f,"color",false);
		fixpars[5] = new EfloyParam(1f,10f,1f,2f,"NumberOfNeighbors",false);
		fixpars[6] = new EfloyParam(0f,0.2f,0.01f,0.1f,"MutationFactor",false);
		fixpars[7] = new EfloyParam(0f,1f,0.1f,1f,"CrossoverFactor",false);

                fixpars[8] = new EfloyParam(0f,16000f,1f,1000f,"energy",true);
                fixpars[9] = new EfloyParam(0f,16000f,1f,10f,"safety",true);
                fixpars[10] = new EfloyParam(0f,16000f,1f,10f,"cooperation",true);
		
                fixpars[11] = new EfloyParam(0f,16000f,1f,1000f,"fitness",true);



		envpars = new EfloyParam[15];

		float h = (float) canvas.size().height;
		float w = (float) canvas.size().width;

		envpars[0] = new EfloyParam(100f,1000f,10f,w,"width",false);
		envpars[1] = new EfloyParam(100f,1000f,10f,h,"height",false);
		envpars[2] = new EfloyParam(1f,10f,1f,4f,"v0",false);
                envpars[3] = new EfloyParam(5f,50f,5f,100f,"sleep",false);
		envpars[4] = new EfloyParam(0f,50f,5f,30f,"margin",false);

		envpars[5] = new EfloyParam(0f,10f,1f,1f,"EnergyFactor",true);
		envpars[6] = new EfloyParam(0f,10f,1f,1f,"SafetyFactor",true);
                envpars[7] = new EfloyParam(0f,10f,1f,1f,"CooperationFactor",true);
		envpars[8] = new EfloyParam(0f,100f,10f,0f,"SurviversFactor",true);

 		envpars[9] = new EfloyParam(-10f,10f,1f,1f,"MaxEnergyDose",true);
		envpars[10] = new EfloyParam(-10f,10f,1f,1f,"MaxSafetyDose",true);
		envpars[11] = new EfloyParam(-10f,10f,1f,1f,"MaxCooperationDose",true);

		envpars[12] = new EfloyParam(5f,50f,5f,15f,"PopulationSize",true);
		envpars[13] = new EfloyParam(0.01f,0.1f,0.01f,0.05f,"FreeWillFactor",true);
		envpars[14] = new EfloyParam(10f,200f,10f,50f,"LifeSpan",true);

	}


	void InitParamsExtended() {

		params = new EfloyParam[12];

                params[0]  = new EfloyParam(1f,5f,0.25f,1f,"MaxSpeed",true);
		params[1]  = new EfloyParam(0.2f,2.2f,0.1f,0.8f,"BounceSpeed",true);
		params[2]  = new EfloyParam(0.1f,2.1f,0.1f,0.3f,"ApproachAcceleration",true);
		params[3]  = new EfloyParam(0.1f,2.1f,0.1f,0.3f,"RetreatAcceleration",true);
		params[4]  = new EfloyParam(0f,0.2f,0.01f,0.1f,"CenterAcceleration",true);

		params[5]  = new EfloyParam(-10f,10f,1f,1f,"DistBrotherFactor",true);
                params[6]  = new EfloyParam(1f,10f,1f,1f,"DistStrangerFactor",true);
		params[7]  = new EfloyParam(-50f,50f,5f,0f,"DistLocalFactor",true);

		params[8]  = new EfloyParam(0f,500f,25f,200f,"CollisionDistance",true);

		params[9]  = new EfloyParam(-10f,10f,1f,-1f,"CollisionBrotherFactor",true);
		params[10] = new EfloyParam(-100f,100f,10f,30f,"CollisionStrangerFactor",true);
		params[11] = new EfloyParam(-100f,100f,10f,-40f,"CollisionLocalFactor",true);



		fixpars = new EfloyParam[12];

		fixpars[0] = new EfloyParam(1f,100f,1f,(float) CurrentNum,"id",false);
		fixpars[1] = new EfloyParam(1f,100f,1f,0f,"father",false);
		fixpars[2] = new EfloyParam(1f,100f,1f,0f,"mother",false);
		fixpars[3] = new EfloyParam(0f,10f,1f,0f,"type",false);
		fixpars[4] = new EfloyParam(0f,13f,1f,5f,"color",false);
		fixpars[5] = new EfloyParam(1f,10f,1f,2f,"NumberOfNeighbors",false);
		fixpars[6] = new EfloyParam(0f,0.2f,0.01f,0.1f,"MutationFactor",false);
		fixpars[7] = new EfloyParam(0f,1f,0.1f,1f,"CrossoverFactor",false);

                fixpars[8] = new EfloyParam(0f,16000f,1f,1000f,"energy",true);
                fixpars[9] = new EfloyParam(0f,16000f,1f,10f,"safety",true);
                fixpars[10] = new EfloyParam(0f,16000f,1f,10f,"cooperation",true);
		
                fixpars[11] = new EfloyParam(0f,16000f,1f,1000f,"fitness",true);

		envpars = new EfloyParam[15];

		float h = (float) canvas.size().height;
		float w = (float) canvas.size().width;

		envpars[0] = new EfloyParam(100f,1000f,10f,w,"width",false);
		envpars[1] = new EfloyParam(100f,1000f,10f,h,"height",false);
		envpars[2] = new EfloyParam(1f,10f,1f,4f,"v0",false);
                envpars[3] = new EfloyParam(5f,50f,5f,100f,"sleep",false);
		envpars[4] = new EfloyParam(0f,50f,5f,30f,"margin",false);

		envpars[5] = new EfloyParam(0f,10f,1f,1f,"EnergyFactor",true);
		envpars[6] = new EfloyParam(0f,10f,1f,1f,"SafetyFactor",true);
                envpars[7] = new EfloyParam(0f,10f,1f,1f,"CooperationFactor",true);
		envpars[8] = new EfloyParam(0f,100f,10f,0f,"SurviversFactor",true);

 		envpars[9] = new EfloyParam(0f,20f,1f,10f,"MaxEnergyDose",true);
		envpars[10] = new EfloyParam(0f,20f,1f,10f,"MaxSafetyDose",true);
		envpars[11] = new EfloyParam(0f,20f,1f,10f,"MaxCooperationDose",true);

		envpars[12] = new EfloyParam(5f,50f,5f,15f,"PopulationSize",true);
		envpars[13] = new EfloyParam(0f,0.1f,0.01f,0.05f,"FreeWillFactor",true);
		envpars[14] = new EfloyParam(10f,200f,10f,50f,"LifeSpan",true);

	}


	static String EncodeChrom(EfloyParam pars[]) {

		int i;
                //char kar;
                String kar;
		String st;
		StringBuffer sb = new StringBuffer(pars.length);

                for(i=0; i<pars.length; i++) {
			kar = pars[i].EncodeValue();
			sb.append(kar);
		}

		st = sb.toString();
                //System.out.println(st);
		return st;

	}


	
	static public void reset() {

                KICK = (float) 0.005;
		SLEEP = 10;

	}
	

        private static int GetFloyNumber(int fid) {

		int i, num;

		num = -1;
		for (i=0;i<Efloys.length;i++)
	 	{
			if (Efloys[i].id == fid)
				num= i;
		}
		return num;

	}

	public void ReleaseStranger() {
                int num = GetFloyNumber(0);
                Efloys[num] = (GooEfloy)(new PredEfloy(params, EncodeChrom(params), fixpars, EncodeChrom(fixpars), envpars, EncodeChrom(envpars)));
                Efloys[num].id = 0;
                Efloys[num].energy *= 2;
                Efloys[num].safety = 5;
                Efloys[num].cooperation = 10;
                Efloys[num].GetFitness();
		Efloys[num].x = canvas.size().width;
		Efloys[num].y = 0;
                Efloys[num].CenterAcceleration = 0.1f;
                Efloys[num].GetNeighbors();
                //randemize();
	}


	public boolean mouseEnter(Event evt, int x, int y) {

	
		if (evt.target == Start) {
			showStatus("Restart the Floys population with identical default values");
		}
		if (evt.target == Scramble) {
			showStatus("Give a high dose of radiation, causing many mutations and diverse population");
		}
		if (evt.target == Pause) {
			showStatus("Freeze all movement. A second click will resume movement");
		}
		if (evt.target == Evolution) {
                        showStatus("Start/Stop a continuous process, where breeding occurs each time a floy is killed");
		}
		if (evt.target == Rules) {
			showStatus("Display eFloys behavioral rules and the rules of the game");
		}
		if (evt.target == Info) {
			showStatus("Display Floys' traits, environmental properties and history data");
		}
		if (evt.target == Control) {
			showStatus("Modify individual or global properies - assign different colors to modified Floys");
		}
		if (evt.target == Slower) {
			showStatus("Define a slower Floy movement - click multiple time to get the desired effect");
		}
		if (evt.target == Faster) {
			showStatus("Define a faster Floy movement - click multiple time to get the desired effect");
		}
		if (evt.target == Stranger) {
                        showStatus("Release a red predator into the territory, it will chase and attack local Floys ");
		}
 		if (evt.target == Breed) {
			showStatus("Create a new generation, where each new Floy is the descendant of two old parents");
		}
 		if (evt.target == Help) {
			showStatus("Display help screen. Close the help screen by clicking its top right X icon");
		}
 		if (evt.target == Log) {
			showStatus("Display Log screen (log notes of current session). Close by clicking top right X icon");
		}
 		if (evt.target == Predefined) {
			showStatus("Select a set of predefined properties that define a specific environment and/or population");
		}

 		if (evt.target == Numbers) {
			showStatus("Toggle between display of Floys (fish like) shape and Floys identity numbers");
		}
 		if (evt.target == Sound) {
 			showStatus("Turn Off or On the sound effects (e.g. the sigh of a dying Floy)");
		}
 		if (evt.target == Ranges) {
 			showStatus("Limit/Reset variation ranges of properties during evolution");
		}
		
		return true;
	}


	public void Restart(boolean Reset) {

		int i;
		String st, fx, ev;

		if (Reset) {
			HistoryData.removeAllElements();

                        setEvolution(false);
			NewGeneration = false;
			CurrentStep = 0;
			CurrentTotalStep = 0;
			CurrentGeneration = 0;

			ResetPopulation = true;
			stop();
			First = true;
			showStatus("");
			start();
		}

		if (ResetPopulation) {
                        Efloys = new GooEfloy[(int)envpars[12].value];
                        deb.showMsg(Efloys.length+" Floys");
			for (i=0;i<Efloys.length;i++) {
				CurrentNum = i;
				st = EncodeChrom(params);
				fx = EncodeChrom(fixpars);
				ev = EncodeChrom(envpars);
				Efloys[i] = new Efloy(params, st, fixpars, fx, envpars, ev);
				Efloys[i].id = i;
			}
                        for (i=0;i<Efloys.length;i++)
                                Efloys[i].GetNeighbors();
                        //randemize();
			ResetPopulation = false;
		}

	}


	public void ResizeFrame(Frame frame) {

		Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
		int w = d.width;
		int h = d.height;
		//frame.hide();
		frame.reshape(0,0,w,h);

		frame.show();

		/*
		int fw = 640;
		int fh = 480;
		int dw = (int) (w - fw)/2;
		int dh = (int) (h - fh)/2;
		frame.reshape(dw,dh,fw,fh);
		*/

	}


	public void CenterFrame(Frame frame) {

		Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
		int w = d.width;
		int h = d.height;
		int fw = 640;
		int fh = 480;
		int dw = (int) (w - fw)/2;
		int dh = (int) (h - fh)/1;
		frame.move(dw,dh);

	}


	void UpdateFloysParams() {

		int i;
		String st, fx, ev;

                for (i=0; i<Efloys.length; i++) {
			Efloys[i].params = params;
			Efloys[i].fixpars = fixpars;
			Efloys[i].envpars = envpars;
			st = EncodeChrom(params);
			fx = EncodeChrom(fixpars);
			ev = EncodeChrom(envpars);
			Efloys[i] = new Efloy(params, st, fixpars, fx, envpars, ev);
			Efloys[i].id = i;
		}
                for (i=0;i<Efloys.length;i++)
                        Efloys[i].GetNeighbors();
	}


	public boolean mouseExit(Event evt, int x, int y) {

		showStatus("");
		return true;

	}

	public boolean keyDown(Event evt, int key) {

		char c = (char) key;

		if (c == Event.F1) {
			helpwin.toFront();
			return true;
		}
		else
		if (c == Event.F2) {
			deb.toFront();
			return true;
		}
		else
		if (c == Event.F3) {
			deb.clear();
			return true;
		}
		else
		if (c == Event.F4) {
			InLog = false;
			return true;
		}
		else
		if (c == Event.F5) {
                        InLog = true;
			return true;
		}
		else
		if (c == Event.F6) {
			KickAll();
			return true;
		}
		else
			return false;

	}


	public boolean action(Event evt, Object o) {

		int i,j;
                GooEfloy Efloy;
		boolean rt = true;
		String s1, s2, s3, s4;
		long oldtime, newtime, timediff;

		if(evt.target == Quit) {
			showStatus("Quit");
			//destroy();
			//System.exit(0);
			try {
				MainPage = new URL("Javafloys.html");
				appcontext.showDocument(MainPage);
			}
			catch (MalformedURLException e){
			}
			rt=true;
		}

		else if (evt.target == Pause) {

			if (running) {
				runner.suspend();
				running = false;
				Pause.setLabel("Continue");
			}
			else {
				runner.resume();
				running = true;
				Pause.setLabel("Pause");
			}
			rt = true;
		}

		else if (evt.target == Evolution) {

			if (InEvolution) {
                                setEvolution(false);
				NewGeneration = false;
				showStatus("");
			}
			else {
                                setEvolution(true);
				NewGeneration = true;
				showStatus("");
			}
			rt = true;

		}


		else if (evt.target == Info) {
			
			MainTitle.setForeground(Color.blue);
			String OldTitle = MainTitle.getText();
			MainTitle.setText("Loading Info Screen, please wait..");
			MainTitle.resize(MainTitle.preferredSize());

			showStatus("Loading Info Screen, please wait..");
			finfo = new EfloyInfo(Efloys);
			ResizeFrame(finfo);
			MainTitle.setText(OldTitle);
			MainTitle.setForeground(Color.black);


		}

		else if (evt.target == Control) {
			
			MainTitle.setForeground(Color.blue);
			String OldTitle = MainTitle.getText();
			MainTitle.setText("Loading Properties Screen, please wait..");
			MainTitle.resize(MainTitle.preferredSize());

			showStatus("Loading Control Screen, please wait..");
			fcommand = new EfloyCommand(Efloys);
			ResizeFrame(fcommand);
			MainTitle.setText(OldTitle);
			MainTitle.setForeground(Color.black);



		}

		else if (evt.target == Stranger) {
			
			ReleaseStranger();

		}

		else if (evt.target == Start) {
			
			if (!running) {
				runner.resume();
				running = true;
				Pause.setLabel("Pause");
			}

			deb.clear();
			deb.start();
			InitParamsExtended();
                        setEvolution(false);
			NewGeneration = false;
			CurrentStep = 0;
			CurrentTotalStep = 0;
			CurrentGeneration = 0;

			ResetPopulation = true;
			Restart(true);

		}

		else if (evt.target == Scramble) {
			
			if (WithSound)
				beep.play();
			scramble();

		}


		else if (evt.target == Breed) {

			if (WithSound)
				beep.play();
			CreateNewGeneration();

		}


		else if (evt.target == Slower) {
                        ++SLEEP;

		}

		else if (evt.target == Faster) {
                        if( SLEEP > 0 ) --SLEEP;
                        else
                                showStatus("THAT'S AS SLOW AS IT GETS!");
		}

		else if (evt.target == Help) {
			//helpwin.toFront();
			helpwin.show();
			rt = true;
		}

		else if (evt.target == Rules) {
			//rulewin.toFront();
			rulewin.show();
			rt = true;
		}
		
		else if (evt.target == Log) {
			//deb.toFront();
			deb.show();
			rt = true;
		}

		else if (evt.target == Predefined) {

			fpredefined = new EfloyPredefined();
			ResizeFrame(fpredefined);
			rt = true;

		}

		else if (evt.target == Numbers) {
			if (DrawNumbers) {
				Numbers.setLabel("Show Numbers");
				DrawNumbers = false;
			}
			else {
				Numbers.setLabel("Show Shapes");
				DrawNumbers = true;
			}
			//DrawNumbers = !DrawNumbers;
			rt = true;
		}

		else if (evt.target == Sound) {
			if (WithSound) {
				Sound.setLabel("Turn Sound On");
			}
			else {
				Sound.setLabel("Turn Sound Off");
			}
			WithSound = !WithSound;
			rt = true;
		}

		else if (evt.target == Ranges) {

			if (LimitedRanges) {
				Ranges.setLabel("Limited Ranges");
				InitParamsExtended();
				UpdateFloysParams();
				LimitedRanges = false;
			}
			else {
				Ranges.setLabel("Normal Ranges");
				InitParamsLimited();
				UpdateFloysParams();
				LimitedRanges = true;
			}
			rt = true;

			/*
			remove(canvas);
			add("Center",center);
			center.repaint();
			repaint();
			showStatus("Center");
			*/
		}

		else {
			rt = true;
		}


		//showStatus("evt.target= "+evt.target.toString());
		return rt;
	}


	public boolean handleEvent(Event evt) {

		if(evt.id == Event.WINDOW_DESTROY) {
			showStatus("Window Distroy");
			destroy();
			System.exit(0);
		}
		else
		if (evt.id == Event.MOUSE_DOWN) {
			//deb.toBack();
			deb.hide();
		}


		return super.handleEvent(evt);
	}

	void SortFloys() {

		int i,j;
		boolean swap;
		int e;
                GooEfloy etemp;

		for (i=0;i < Efloys.length-1;i++) {
			swap = false;
			for (j=Efloys.length-2;j>=i;j--) {
				Efloys[j].GetFitness();
				Efloys[j+1].GetFitness();
				e = Efloys[j].fitness - Efloys[j+1].fitness;
				if (e < 0) {
					etemp = Efloys[j];
					Efloys[j] = Efloys[j+1];
					Efloys[j+1] = etemp;
					swap = true;
				}
			}
			if (swap == false) {
				break;
			}
		}

	}

        public void setEvolution(boolean evolve) {
                InEvolution = evolve;
                if( evolve ) {
				Evolution.setLabel("Stop Evolution");
                } else {
                                Evolution.setLabel("Start Evolution");
                }
        }

        void SortFloys(GooEfloy[] floys) {

		int i,j;
		boolean swap;
		int e;
                GooEfloy etemp;

		for (i=0;i < floys.length-1;i++) {
			swap = false;
			for (j=floys.length-2;j>=i;j--) {
				Efloys[j].GetFitness();
				Efloys[j+1].GetFitness();
				e = floys[j].fitness - floys[j+1].fitness;
				if (e < 0) {
					etemp = floys[j];
					floys[j] = floys[j+1];
					floys[j+1] = etemp;
					swap = true;
				}
			}
			if (swap == false) {
				break;
			}
		}

	}

        private long FindSumFitness(Class floyClass) {
                Long l = (Long)(SumFitnessTable.get(floyClass));
                return l.longValue();
        }

        private void GetSumFitness() {
                Class floyClass;
                SumFitness = 0;
                SumFitnessTable.clear();
                for(int i=0;i < Efloys.length;i++) {
                        if( !SumFitnessTable.containsKey(Efloys[i].getClass()) ) {
                                floyClass = Efloys[i].getClass();
                                long sumfit = GetSumFitness(floyClass);
                                SumFitnessTable.put(floyClass, new Long(sumfit));
                                SumFitness += sumfit;
                        }
		}
                // calc the global sum fitness as average of all fitnesses
                SumFitness = SumFitness / SumFitnessTable.size();
        }

        private long GetSumFitness(Class floyClass) {

                int i, numClass = 0;
		long sum;
                //float eng, avg, saf;
                int  cop, saf;
                //float facavg, facsaf;

                //eng = 0;
                cop = 0;
		saf = 0;
		sum = 0;

                
		for (i=0;i < Efloys.length;i++) {
                        if( Efloys[i].getClass().equals(floyClass) ) {
                                ++numClass;
                                //eng = eng + (float) Efloys[i].energy;
                                cop = cop + Efloys[i].cooperation;
                                saf = saf + Efloys[i].safety;
                        }
		}
                /*
		avg = 100;
                facavg = eng/numClass/avg;
		facsaf =  saf/eng;
                */

                cop = cop / numClass;
                saf = saf / numClass;

                for (i=0;i < Efloys.length;i++) {
                        if( Efloys[i].getClass().equals(floyClass) ) {
                                // havent figured old code but my guess is similar
                                // smoothing function to prevent exceeding maximums
                                //Efloys[i].energy = (int) (Efloys[i].energy/facavg);
                                //Efloys[i].safety = (int) (Efloys[i].safety/facavg/facsaf);
                                Efloys[i].SmoothingFunction(cop, saf);
                                Efloys[i].GetFitness();
                                sum = sum + Efloys[i].fitness;
                        }
		}
		return sum;
	}

		
        private int GetParentID(Class floyClass) {
		int i,j,k,n;
		int rand, partsum;
		i = 0;
		partsum = 0;
                //n = Efloys.length;
                rand =(int) (Math.random()*FindSumFitness(floyClass));
                //int avg = (int) (SumFitness/n);

		j = 0;
		for (i=0;i<Efloys.length;i++) {
                        if( Efloys[i].getClass().equals(floyClass) ) {
                                Efloys[i].GetFitness();
                                partsum = partsum + (int) Efloys[i].fitness;
                                if (partsum >= rand) {
                                        j = 1;
                                        break;
                                }
                        }
		}
		
		if (j == 0) {
                        for(;j < Efloys.length; j++) {
                                if( Efloys[j].getClass().equals(floyClass) ) {
                                        i = j;
                                        break;
                                }
                        }
		}
		//deb.showMsg("i= "+i+" j= "+j+" Sum= "+(int) SumFitness+" Avg = "+(int) avg+
		//	" Rand = "+(int) rand+" Part= "+partsum+" Fit= "+Efloys[i].fitness+" id = "+Efloys[i].id);

		return Efloys[i].id;	
        }
        /**
        * Get a parent based on fitness over entire population
        * modified by random threshold of partial sum
        * sort of a global fitness function
        * @return The ID of the prospective parent
        */
	private int GetParentID() {

		int i,j,k,n;
		int rand, partsum;

		i = 0;
		partsum = 0;
		//n = Efloys[0].PopulationSize;
		n = Efloys.length;

		rand =(int) (Math.random()*SumFitness);
                //int avg = (int) (SumFitness/n);

		j = 0;
		for (i=0;i<Efloys.length;i++) {
			Efloys[i].GetFitness();
			partsum = partsum + (int) Efloys[i].fitness;
			if (partsum >= rand) {
				j = 1;
				break;
			}
		}

		/*
		while ((partsum < rand) && (i < n-1))  {
			partsum += (float) Efloys[i].fitness;
			i++;
		}
		*/
		
		if (j == 0) {
			i = Efloys.length-1;
		}

		//deb.showMsg("i= "+i+" j= "+j+" Sum= "+(int) SumFitness+" Avg = "+(int) avg+
		//	" Rand = "+(int) rand+" Part= "+partsum+" Fit= "+Efloys[i].fitness+" id = "+Efloys[i].id);

		return Efloys[i].id;	

	}

        /**
        * The mating process involves finding a floy of the same type
        * (subclass instance of GooEfloy) and performing crossover and possible mutation<p>
        * @return The GooEfloy subclassed instance of mating result
        */
        private GooEfloy Mate() {
                int MomID = GetParentID();
                GooEfloy Mom = Efloys[GetFloyNumber(MomID)];
                return Mate(Mom);
        }
        /**
        * The mating process involves finding a floy of the same type
        * (subclass instance of GooEfloy) and performing crossover and possible mutation<p>
        * A mate will always be found eventually, even if its yourself<p>
        * Proper births are performed by abstract method BabyFactory in GooEfloy
        * which return the correct instance of the mated subclass.<p>
        * We wont get into recombinant dna just yet.
        * @param Mom The mother to mate
        * @return The GooEfloy subclassed instance of mating result
        */
        private GooEfloy Mate(GooEfloy Mom) {

		int MomID, DadID;
                GooEfloy Dad, Kid;
		String KidChrom, fx, ev;
		
                MomID = Mom.id;
                // Ultimately, mom decides who to mate with
                DadID = GetParentID(Mom.getClass());
		Dad = Efloys[GetFloyNumber(DadID)];

                //deb.showMsg("Mating Dad "+Dad.getClass().getName()+" "+DadID+" and Mom "+Mom.getClass().getName()+" "+MomID);

		KidChrom = Dad.CrossOver(Mom.chrom);

		fx = EncodeChrom(fixpars);
		ev = EncodeChrom(envpars);
                Kid = Mom.BabyFactory(params, KidChrom, fixpars, fx, envpars, ev);
                Kid.color = Mom.color;
		Kid.chrom = Kid.mutate();
		Kid.energy = (int) ((Dad.energy + Mom.energy)/2);
		Kid.safety = (int) ((Dad.safety + Mom.safety)/2);
		Kid.cooperation = (int) ((Dad.cooperation + Mom.cooperation)/2);
		Kid.GetFitness();

                // Assign position in BabyFactory depending on how they lay eggs (or lay themselves ;)
                //Kid.x = 10;
                //Kid.y = 10;
		canvas.repaint();

		/*
		deb.showMsg("---");
		deb.showMsg("SumFitness = "+SumFitness);
		deb.showMsg("Mom = "+MomID+": "+Mom.chrom+" Fit= "+Mom.fitness);
		deb.showMsg("Dad = "+DadID+": "+Dad.chrom+" Fit= "+Dad.fitness);
		deb.showMsg("Kid = "+KidChrom+" Kid.chrom= "+Kid.chrom);
		*/
                /*
                if( Mom.getClass().equals(PredEfloy.class) ){
		deb.showMsg("---");
                deb.showMsg("Mom "+Mom.id+" "+Mom.getClass().getName()+" energy "+Mom.energy);
                deb.showMsg("Dad "+Dad.id+" "+Dad.getClass().getName()+" energy "+Dad.energy);
                deb.showMsg("Kid "+Kid.getClass().getName()+" energy "+Kid.energy);
                }
                */

		return Kid;
	}

        /**
        * Create a new population.  Called from CreateNewGeneration
        */
	private void Breed() {
		int i,n;

                //SumFitness = GetSumFitness();
                GetSumFitness();

                NewFloys = new GooEfloy[Efloys.length];

		for (i=0;i<Efloys.length;i++) {
			//deb.showMsg("Making kid #"+i);
			NewFloys[i] = Mate();
			NewFloys[i].id = i;
		}
		if (Efloys[0].SurviversFactor > 0) {
			SortFloys(Efloys);
			SortFloys(NewFloys);
			n = (int) (Efloys.length*Efloys[0].SurviversFactor/100);
			for (i=0;i<Efloys.length;i++) {
				if (i > (n-1))
					Efloys[i] = NewFloys[i-n];
			}
		}
		else {
			for (i=0;i<Efloys.length;i++)
					Efloys[i] = NewFloys[i];
		}
	}

        /**
        * Decompose and produce new life form<p>
        * This happens when a higher form dies and produces mated lower forms<br>
        * The eLadderFactor determines evolutionary level, ascending<br>
        * Two lower forms are selected to mate, their offspring 'feeding' off the carcass
        * @param rotter The carcass of a dead higher lifeform
        */
        public synchronized void Rot(GooEfloy rotter) {
                int tid = rotter.id;
                for(int i = 0; i < Efloys.length; i++) {
                        if( Efloys[i].eLadderFactor < rotter.eLadderFactor ) {
                                int idex = GetFloyNumber(rotter.id);
                                Efloys[idex] = Mate(Efloys[i]);
                                Efloys[idex].id = tid;
                                return;
                        }
                }
        }
        /**
        * Decompose and produce same life form<p>
        * This happens when a form dies and produces mated forms<br>
        * This is used to regenerate the lowest active form, call from subclass of GOOEfloy
        * @param rotter The carcass of a dead higher lifeform
        */
        public synchronized void RotRegardless(GooEfloy rotter) {
                int tid = rotter.id;
                int idex = GetFloyNumber(rotter.id);
                int i = GetFloyNumber(GetParentID(rotter.getClass()));
                Efloys[idex] = Mate(Efloys[i]);
                Efloys[idex].id = tid;
        }

        /**
        * When presented with a percentage possibility (scaled 0-1)
        * a true or false results
        * @param ref The percentage possibility
        * @return true if event 'happened'
        */
	static boolean Flip(float ref) {

		float rand = (float) Math.random();
		if (rand < ref)
			return true;
		else
			return false;

	}


        /**
        * Prescales the fitness of each FLoy over the entire population
        * more than this I cannot say...
        */
	private void PreScale() {
                
		int i;
		double tmin = 10e35;
		double tmax = -10e35;
		double tsum = 0;

                int size = Efloys.length;
		for (i=0;i<size;i++) {
			Efloys[i].GetFitness();
			if (Efloys[i].fitness < tmin)
				tmin = Efloys[i].fitness;
			if (Efloys[i].fitness > tmax)
				tmax = Efloys[i].fitness;
			tsum = tsum + Efloys[i].fitness;
		}

		double tavg = tsum/size;
		double temp = (tmax+tmin)/2;
		double factor = 1.80; //gadef.params.scale; (Default: 1.80)
		double a_coeff = 1;
		double b_coeff = 0;
		double delta;
		
		//deb.showMsg("tsum= "+tsum+" size = "+size+" tavg= "+tavg);
		//deb.showMsg("tmax= "+tmax+" tmin = "+tmin+" temp= "+temp);
		//deb.showMsg("factor= "+factor+" a = "+a_coeff+" b= "+b_coeff);

		if (factor > 1) {
				if (tmin > (factor * tavg - tmax) / (factor - 1)) {
					delta = tmax - tavg;
					if (delta != 0) {
						a_coeff = (factor - 1) * tavg / delta;
						b_coeff = tavg * (tmax - factor * tavg) / delta;
					}
				}
		}
		else {
				delta = tavg - tmin;
				if (delta != 0) {
					a_coeff = tavg / delta;
					b_coeff = -tmin * tavg / delta;
				}
		}

		//deb.showMsg("After. factor= "+factor+" a = "+a_coeff+" b= "+b_coeff);
		//deb.showMsg("Before 0 = "+Efloys[0].fitness+" 1= "+Efloys[1].fitness);

		for (i=0;i<size;i++)
			Efloys[i].fitness = (int) (Efloys[i].fitness*a_coeff + b_coeff);

		//deb.showMsg("After 0 = "+Efloys[0].fitness+" 1= "+Efloys[1].fitness);
		//deb.showMsg(" ");

		//SortFloys();
		
	}

	
	void CreateHelp(EfloyLog win) {

		int i;
		String txt;

		win.ta.setForeground(Color.black);
		win.ta.setFont(new Font("TimesRoman",Font.BOLD,12));
		win.clear();

		txt = "";

		txt = txt + "Contents\n\n";
		txt = txt + "1.\t Button Functions\n";
		txt = txt + "2.\t Properties\n";
		
		txt = txt + "\n\n";

		txt = txt + "Button Functions - Bottom Button Bar\n\n";

                txt = txt + "Restart:\t\t Restart the GOOeFloys population with identical default values\n";
		txt = txt + "Scramble:\t\t Give a high dose of radiation, causing many mutations and diverse population\n";
                txt = txt + "Breed:\t\t Create a new generation, where each new GOOeFloy is the descendant of two old parents\n";
                txt = txt + "Evolution:\t\t Start/Stop a continuous process, where breeding occurs each time a floy is killed\n";
                txt = txt + "Insert Predator:\t Release a red predator into the territory, it will chase and attack local Floys\n";

		txt = txt + "\nButton Functions - Right Button Bar\n\n";

		txt = txt + "Show Help:\t Display help screen. Close the help screen by clicking its top right X icon\n";
		txt = txt + "Show Log Screen:\t Display Log screen (log notes of current session). Close by clicking top right X icon\n";
		txt = txt + "Predefined:\t\t Select a set of predefined properties that define a specific environment and/or population\n";
                txt = txt + "Show Rules:\t\t Display GOOeFloys behavioral rules, and the rules of the game\n";
                txt = txt + "Show Info:\t Display GOOeFloys' traits, environmental properties and history data\n";
                txt = txt + "Edit Properties:\t Modify global properies\n";
		
		
		txt = txt + "\nButton Functions - Left Button Bar\n\n";

                txt = txt + "Show Numbers:\t Toggle between display of GOOeFloys (fish like) shape and GOOeFloys identity numbers\n";
                txt = txt + "Turn Sound Off:\t Turn Off or On the sound effects (e.g. the chirp or bark of a dying GOOeFloy)\n";
                txt = txt + "Slower:\t\t Slow the GOOeFloy movement - click multiple time to get the desired effect\n";
                txt = txt + "Faster:\t\t Make GOOeFloy movement more rapid - click multiple time to get the desired effect\n";
		txt = txt + "Pause:\t\t Freeze all movement. A second click will resume movement\n";
                txt = txt + "Limited Ranges:\t\t Limit variation ranges for critical properties\n";
		

                txt = txt + "\n\nDescription of Properties\n\n";

		txt = txt + "Primary Traits:\t The main behavioral traits, affected by evolutionary operators (crossover and mutation)\n";
		txt = txt + "Secondary Traits:\t The specific responses to various inputs, affected by the evolutionary operators\n";
		txt = txt + "Fixed traits:\t Various individual traits, not affected by the evolutionary operators\n";
		txt = txt + "Environmental:\t These are properties of the environment, and are shared by the whole community\n";
		txt = txt + "\n";

		txt = txt + "Primary Traits\n\n";
                txt = txt + "Maximum Speed:\t The maximum speed a GOOeFloy can reach\n";
		txt = txt + "Bounce Speed:\t The speed of turning away when hitting a wall\n";
		txt = txt + "Acceleration:\t The basic acceleration of response to various inputs\n";
                txt = txt + "Attract to Center:\t The force by which a GOOeFloy is attracted to the center of the territory\n";
                txt = txt + "Collision Distance:\t The distance (squared) at which a GOOeFloy can touch another\n";
		txt = txt + "\n";


		txt = txt + "Secondary Traits:\n\n";
                txt = txt + "Response (speed and direction change) to a distant GOOeFloy\n";
                txt = txt + "Distance Brother:\t A GOOeFloy's movement response to a member of its own type\n";
                txt = txt + "Distance Stranger:\t A GOOeFloy's movement response to a foreigner\n";
		txt = txt + "\n";

                txt = txt + "Response (speed and direction change) to a close GOOeFloy (at touching distance)\n";
                txt = txt + "Collision Brother:\t A GOOeFloy's movement response to colliding with a member of its own type\n";
                txt = txt + "Collision Stranger:\t A GOOeFloy's movement response to colliding with a foreigner\n";
		txt = txt + "\n";

		txt = txt + "Environmental Properties\n\n";
                txt = txt + "Population Size:\t The number of GOOeFloys in the community\n";
                txt = txt + "Movement Slowdown Attribute:\t A delay factor for adjusting the overall movement speed\n";
                txt = txt + "Energy Weight Factor:\t The weighting factor of energy in the fitness function\n";
                txt = txt + "Safety Weight Factor:\t The weighting factor of safety in the fitness function\n";
                txt = txt + "Cooperation Weight Factor:\t The weighting factor of cooperation in the fitness function\n";
                txt = txt + "Max. Energy Dose:\t Maximum energy points (reward or penalty) a GOOeFloy can get or lose\n";
                txt = txt + "Max. Safety Dose:\t Maximum safety points (reward or penalty) a GOOeFloy can get or lose\n";
                txt = txt + "Max. Coop, Dose:\t Maximum cooperation points (reward or penalty) an GOOeFloy can get or lose\n";
                txt = txt + "Survivers Percent:\t The percentage of parents that are allowed to continue in the new generation (if 0, all)\n";
                txt = txt + "Free Will Factor:\t The amount of random movement behavior, or the chance of 'seeing' other than your closest neighbors \n";

                txt = txt + "All GOOeFloys share the following fixed Traits\n\n";
                txt = txt + "Color:\t\tA GOOeFloy with a red color is typically a predator\n";
                txt = txt + "Color is Useful for observing and following specific GOOeFloys\n";
                txt = txt + "No. of Neighbors:\t The number of GOOeFloys to relate to\n";
		txt = txt + "Mutation Factor:\t The probability for a gene to be changed by mutation\n";
		txt = txt + "Crossover Factor:\t The probability for crossover in the breeding process (in general should be 1)\n";
                txt = txt + "Energy Level:\t A dynamic attribute, affected by movement and interaction with strangers\n";
		txt = txt + "Safety Level:\t A dynamic attribute, affected by interaction with one's neighbors\n";
                txt = txt + "Cooperation Level:\t A dynamic attribute, affected by achieving common goals (such as bumping into or not bumping into each other)\n";
                txt = txt + "Simple common goals are defined by each GOOeFloy subtype\n";
		txt = txt + "Fitness Level:\t Overall fitness calculated as a weighted function of the above\n";
		txt = txt + "\n";


		txt = txt + "\n";

		win.showMsg(txt);

	}


	void CreateRules(EfloyLog win) {

		int i;
		String txt;

		win.ta.setForeground(Color.black);
		win.ta.setFont(new Font("TimesRoman",Font.BOLD,12));
		win.clear();

		txt = "";
                txt = txt + "The instinctive behavioral rules of GOOeFloys\n";
		txt = txt + "\n";

                txt = txt + "GOOeFloys' behavior is governed by two rules:\n";
		txt = txt + "\t1. A rule specifying how to relate to one's own kind.\n";
		txt = txt + "\t2. A rule specifying how to relate to strangers.\n";
		txt = txt + "\n";
		txt = txt + "1. How to relate to one's own kind:\n";
                txt = txt + "\tPrey - Identify two members of your flock that are near to you and try to stay close to them, but not too close.\n";
                txt = txt + "\tPredator - Eschew your own in favor of moving toward prey\n";

		txt = txt + "\n";

		txt = txt + "2. How to relate to strangers:\n";
                txt = txt + "\tPrey - move away from predators\n"; 
                txt = txt + "\tPredator - move toward prey and attack\n";
                txt = txt + "\n";

		txt = txt + "Rewards and Penalties\n";
                txt = txt + "(The fitness is calculated as a weighted function of total energy, safety, and cooperation)\n";
		txt = txt + "\n";

                txt = txt + "Predator biting prey:\t\t Energy increase for predator, and decrease for prey.  Metabloic inefficiency of predator decreases net gain\n";
                txt = txt + "Moving:\t\t\t For both Predator and Prey, energy decrease\n";
                txt = txt + "Prey moving slowly:\t\t\t Likelihood of energy increase is based on slower movement since prey eat freely floating microorganisms\n";
                txt = txt + "Moving toward ones own kind:\t Cooperation increase\n";
                txt = txt + "Prey bumping into prey:\t Safety increase\n\n";
                txt = txt + "Predator bumping into predator:\t Cooperation decrease\n\n";
                txt = txt + "When prey dies, other, fitter prey breed on its carcass (or predator excrement) and come in from the left to join the flock\n";
                txt = txt + "When a predator dies, prey breed on its carcass and come in from the left to join the flock\n";
                txt = txt + "When the last predator dies, a new generation begins\n";
                txt = txt + "At the start of a new generation, when predators are born, they can appear where the last died or come in from the right\n";
                txt = txt + "It is necessary for lower lifeforms to first exist before breeding on remains of higher forms\n";
                txt = txt + "So if predators comsume all prey, no more prey can spawn.  Prey get harder to kill as they get stronger\n";
		txt = txt + "\n\n";

                txt = txt + "How to play with GOOeFloys\n";
		txt = txt + "\n";

		txt = txt + "1. Adjust overall movement speed (if necessary)\n";
		txt = txt + "\tThe default movement should be smooth and calm\n";
		txt = txt + "\tClick the 'Slower' and/or 'Faster' buttons several times to define a smooth movement\n";
		txt = txt + "\n";

		txt = txt + "2. Play with Population\n";
		txt = txt + "\n";

                txt = txt + "\tInsert a predator and watch how prey are chased and attacked\n";
                txt = txt + "\tNotice how emergent flocking bahavior of both predators and prey influence the predation process\n";
                txt = txt + "\tA barking sound means a predator has expired from energy drain\n";
                txt = txt + "\tA chirp sound means prey has expired from energy drain or being eaten\n";
		txt = txt + "\n";
                txt = txt + "\tGo to 'Edit Properties' and modify the environment\n";
                txt = txt + "\tClick 'Update' to apply the new environment\n";
                txt = txt + "\t(Optionally) Insert a predator\n";
		txt = txt + "\n";

		txt = txt + "3. Play with Evolution\n";
		txt = txt + "\n";

		txt = txt + "\tDefine the fitness function\n";
		txt = txt + "\tGo to 'Edit Properties' and assign Energy and Safety Weight Factors\n";
                txt = txt + "\tIf Energy weight is higher, GOOeFloys will evolve to be braver and faster\n";
                txt = txt + "\tIf Safety weight is higher, GOOeFloys will evolve to be more cautious and they will keep together\n";
		txt = txt + "\n";

		txt = txt + "\tStart with a diverse, random population\n";
		txt = txt + "\tClick 'Scramble' several times. Each click will make the population more diverse\n";
		txt = txt + "\tClick 'Start Evolution'\n";
		txt = txt + "\n";

		txt = txt + "\tor Start with a homogeneous population\n";
                txt = txt + "\tUse one of the default population environments using the 'Predefined' button\n";
		txt = txt + "\tClick 'Start Evolution'\n";
		txt = txt + "\n";

		txt = txt + "4. How to use the buttons\n";
		txt = txt + "\tClick on any button and see what it does\n";
		txt = txt + "\tor look in the Help screen (click 'Show Help')\n";
		txt = txt + "\n";

		win.showMsg(txt);

	}



	void KickAll() {

		int i;

		for (i=0;i<Efloys.length;i++) {
			Efloys[i].mutate();
		}

		beep.play();

	}

}




